'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = error;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _log = require('./log');

var _log2 = _interopRequireDefault(_log);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function error(err) {
  if (err.isJoi) err.code = 400;
  if (err.originalError) err = err.originalError;
  if (err.statusCode) err.code = err.statusCode;
  if (err.output) err.code = _lodash2.default.get(err, 'output.statusCode');
  var code = 500;
  var statusCode = Number(err.code);
  if (statusCode && 100 <= statusCode && statusCode < 600) code = statusCode;
  _log2.default.transports.console.label = code;
  if (code >= 500) {
    _log2.default.error(err);
  } else if (process.env.NODE_ENV !== 'production') {
    _log2.default.warn(err.message);
  }
  _log2.default.transports.label = null;
  var response = { message: err.message };
  if (err.data) response.payload = err.data;
  return response;
}